//The sample code for driving one way motor encoder
#include <PID_v1.h>


// PORT POUR KIT L298N 2nd (Bleu clair) supllied with 6 V
//  MOTEUR A  GAUCHE  avec myPIDA 8,9,5,3,7,

//Ports de commande du moteur A supplied with 6 volt.

int motorPinA1 = 9; //13 pin to set H BRIDGE of L298N  
int motorPinA2 = 8; //12 pin to set H BRIDGE of L298N  
const int enablePinA= 5; //11 //  Commande de vitesse moteur, to Output ENA pour L298 the second

//  MOTEUR B Droit  avec myPIDB 10,11,6,2,4
  
//Ports de commande du moteur B supplied with 6 volt.

int motorPinB1 = 10; // pin to set H BRIDGE of L298N
int motorPinB2 = 11; //12 pin to set H BRIDGE of L298N
const int enablePinB= 6; //11 //  Commande de vitesse moteur, to Output ENA pour L298 the second



//MOTOR GAUCHE pin D 3,7,9,8,5
 
volatile byte encoderApinA = 3;//A pin -> the interrupt pin 3
const byte encoderApinB = 7;//B pin -> the digital pin 7

byte encoderAPinALast;  //  volatile byte encoderAPinALast ?
double  latestDurationCountA,durationA,abs_durationA;//the number of the pulses
boolean DirectionA;//the rotation direction 
boolean resultA;

double val_outputA;//Power supplied to the motor PWM value.
double SetpointA;
double Kp=1, Ki=10, Kd=0.01; // 1 ; 10 ; 0.01
PID myPIDA(&abs_durationA, &val_outputA, &SetpointA, Kp, Ki, Kd, DIRECT); 


//**************************************************
//MOTOR DROIT myPIDB motor pinB+encoderB 2,4,11,10,6
volatile byte encoderBpinA = 2;//A pin -> the interrupt pin 1/*volatile byte
const byte encoderBpinB = 4;//B pin -> the digital pin 4

byte encoderBPinALast;
double  latestDurationCountB, durationB, abs_durationB; //the number of the pulses
boolean DirectionB;//the rotation direction 
boolean resultaB;

double val_outputB;//Power supplied to the motor PWM value.
double SetpointB;
//double Kp=0.6, Ki=5, Kd=0; // 0.6 ; 5 ; 0
PID myPIDB(&abs_durationB, &val_outputB, &SetpointB, Kp, Ki, Kd, DIRECT); 


volatile double speedDroit = 0; //(doublon avec lastestdurationCountB? vitesse du moteur  DROIT
volatile double speedGauche = 0; // vitesse du moteur  DROIT

unsigned long time0 = 0; // stock un temps à un instant donné
unsigned long timer = 0; // variable qui va contenir le dernier temps enregistré via millis

int8_t valeur = 40;  //lecture de la consigne via le moniteur serie pour test, initialisé à 40 pour test rapide du PID


void setup()

{  
  Serial.begin(19200);//Initialize the serial port

   // on initialise les entrées (moins precis avec entrées declarées) et sorties
/*
  pinMode(encoderApinA, INPUT); //encodeur moteur A avec interrupt pin
  pinMode(encoderApinB, INPUT);
  pinMode(encoderBpinA, INPUT);////encodeur moteur B avec interrupt pin
  pinMode(encoderBpinB, INPUT);
*/  
   // Configuration des ports en mode "sortie" A   moteur GAUCHE
  pinMode(motorPinA1, OUTPUT);
  pinMode(motorPinA2, OUTPUT);
  pinMode(enablePinA, OUTPUT);

   // Configuration des ports en mode "sortie" B moteur DROIT
   
   pinMode(motorPinB1, OUTPUT);   //L298N Control port settings direction of motor B (originaly L298N)
   pinMode(motorPinB2, OUTPUT);  //L298N Control port settings direction of motor B
   pinMode(enablePinB, OUTPUT);  // powerRate to control speed of motor B
   
   // REGLAGE PID MOTOR A (gauche)
   
   abs_durationA;
   SetpointA; 
   
   myPIDA.SetMode(AUTOMATIC);//PID is set to automatic mode
   myPIDA.SetSampleTime(5);//Set PID sampling frequency is 100ms
   myPIDA.SetOutputLimits(-255, 255);
   
   EncoderInitA();//Initialize the module

   //REGLAGE PID MOTEUR B  (droit)
   abs_durationB;
   SetpointB; 
   
   myPIDB.SetMode(AUTOMATIC);//PID is set to automatic mode
   myPIDB.SetSampleTime(5);//Set PID sampling frequency is 100ms
   myPIDB.SetOutputLimits(-255, 255);
   
   EncoderInitB();//Initialize the module

    // moteurs à l'arret
     stopMotors();
 
}
 
void loop()
{ if (Serial.available()) {
    time0 = timer;
    valeur = Serial.parseInt(); //récupération des caractères sur le port série
    Serial.println("-----------------valeur");Serial.println(valeur);
    
  }
  if (valeur != 0) {
    runMotorSpeed(valeur,valeur);
  }
  else {
    stopMotors();
  }
  timer = millis();
  
  if ( (timer - time0) >10000) { // Timeout !
    valeur = 0 ;
    stopMotors();
    time0 = timer; 

 }
  
 //MOTOR GAUCHE
  /*
      noInterrupts();
      latestDurationCountA = durationA;
      interrupts();
      abs_durationA = abs(latestDurationCountA);

       
      //  SetpointA= 20;//  // with 19200 bauds // SetpointA=20 --> val_outputA=59.55   
    
      
      resultA=myPIDA.Compute();//PID conversion is complete and returns 1
       advanceA();
      if(resultA)
      {
        Serial.print("LD"); Serial.print(latestDurationCountA); 
        Serial.print("D  : ");  Serial.print(durationA); Serial.print(durationA); Serial.print(durationA);
        durationA = 0; //Count clear, wait for the next count
        //Serial.print("SetpointA"); Serial.println(SetpointA);
        Serial.print("V"); Serial.println(val_outputA);// volt to MOTOR= real speed
      }

        // *******************************************


  // SETTING  MOTEUR DROIT PIDB avec PIN B plus rapide?
   
      noInterrupts();
      latestDurationCountB = durationB;
      interrupts();
      abs_durationB = abs(latestDurationCountB);
/*
      // SetpointB=20; //
  
     // resultaB=myPIDB.Compute();//PID conversion is complete and returns 1
     // advanceB();
      
     // if(resultaB)
      {
  
        Serial.print("LDb"); Serial.print(latestDurationCountB);  
        Serial.print("Db: ");  Serial.print(durationB);Serial.print(durationB);Serial.print(durationB); 
        durationB = 0; //Count clear, wait for the next count
        //Serial.print("SetpointB"); Serial.println(SetpointB);
        Serial.print("Va"); Serial.println(val_outputB);// volt to MOTOR= real speed
      }
 */    
}
 
void EncoderInitA()
{
  DirectionA = true;//default -> Forward  
  pinMode(encoderApinB,INPUT);  
  attachInterrupt(1, wheelSpeedA, CHANGE);
}
 
void wheelSpeedA()
{
  byte Lstate = digitalRead(encoderApinA);
  if((encoderAPinALast == LOW) && Lstate==HIGH)
  {
    byte val = digitalRead(encoderApinB);
    if(val == LOW && DirectionA)
    {
      DirectionA = false; //Reverse
    }
    else if(val == HIGH && !DirectionA)
    {
      DirectionA = true;  //Forward
    }
  }
  encoderAPinALast = Lstate; //
  
 
  if(!DirectionA)  durationA++;
  else  durationA--;

}
void advanceA()//Motor Forward
{
     digitalWrite(motorPinA1,HIGH);
     digitalWrite(motorPinA2,LOW);
     
     analogWrite(enablePinA,val_outputA);
}
void backA()//Motor reverse
{
      digitalWrite(motorPinA1,LOW);
     digitalWrite(motorPinA2,HIGH);
     
     analogWrite(enablePinA,val_outputA);
}

void StopA()//Motor stops
{
     digitalWrite(enablePinA, LOW); 
}

void EncoderInitB()
{
  DirectionB = true;//default -> Forward  
  pinMode(encoderBpinB,INPUT);  
  attachInterrupt(0, wheelSpeedB, CHANGE);
}
 
void wheelSpeedB()
{
  byte LstateB = digitalRead(encoderBpinA);
  if((encoderBPinALast == LOW) && LstateB==HIGH)
  {
    byte valB = digitalRead(encoderBpinB);
    if(valB == LOW && DirectionB)
    {
      DirectionB = false; //Reverse
    }
    else if(valB == HIGH && !DirectionB)
    {
      DirectionB = true;  //Forward
    }
  }
  encoderBPinALast = LstateB;
 
  if(!DirectionB)  durationB++;
  else  durationB--;

}
void advanceB()//Motor Forward
{
     digitalWrite(motorPinB1,HIGH);
     digitalWrite(motorPinB2,LOW);
     
     analogWrite(enablePinB,val_outputB);
}
void backB()//Motor reverse
{
      digitalWrite(motorPinB1,LOW);
     digitalWrite(motorPinB2,HIGH);
     
     analogWrite(enablePinB,val_outputB);
}

void StopB()//Motor stops
{
     digitalWrite(enablePinB, LOW); 
}

void stopMotors() {

  digitalWrite(enablePinA, 0);
  digitalWrite(enablePinB, 0);

}


void runMotorSpeed( int8_t commandeMoteurDroit, int8_t commandeMoteurGauche) {// (a, a)

      noInterrupts();
      latestDurationCountA = durationA;
      interrupts();
      abs_durationA = abs(latestDurationCountA);

      noInterrupts();
      latestDurationCountB = durationB;
      interrupts();
      abs_durationB = abs(latestDurationCountB);

  SetpointB = commandeMoteurDroit;
  SetpointA = commandeMoteurGauche;

  durationB = speedDroit;  //ou absdurationB ou latestDurationCountB
  durationA = speedGauche; //ou absdurationA ou LastDurationA

  myPIDB.Compute();
  myPIDA.Compute();

  //durationB=0;
  //durationA=0;
  
  int outputDroit = (int)val_outputB;   // creer nouvelle donnée de val-output egale à (int)val-outputB
  int outputGauche = (int)val_outputA; //gauche

  //utilisation de la sortie du PID pour asservir les moteurs
  if (outputDroit >= 0) {
    advanceB();
  }
  if (outputDroit < 0) {
    backB();
  }
  if (outputGauche >= 0) {
    advanceA();
  }
  if (outputGauche < 0) {
    backA();
  }
        Serial.print("LDDROIT"); Serial.print(latestDurationCountB);  
        Serial.print("Ddroit: ");  Serial.print(durationB);Serial.print(durationB);Serial.print(durationB); 
        
        durationB = 0; //Count clear, wait for the next count
        //Serial.print("SetpointB"); Serial.println(SetpointB);
        Serial.print("Vdroit"); Serial.println(val_outputB);// volt to MOTOR= real speed
//_______________________

        Serial.print("LDGAUCHE"); Serial.print(latestDurationCountA); 
        Serial.print("DGAUCHE  : ");  Serial.print(durationA); Serial.print(durationA); Serial.print(durationA);
        durationA = 0; //Count clear, wait for the next count
        //Serial.print("SetpointA"); Serial.println(SetpointA);
        Serial.print("Vgauche"); Serial.println(val_outputA);// volt to MOTOR= real speed

}

